<?php

namespace CRM\Util;

use \Teknisa\GER\Utilities\Configuration;
use \Zeedhi\Framework\DataSource\Manager\Doctrine\NameProvider;

class NameProviderImpl implements NameProvider {

    public function getClassName($tableName) {}

    public function getDataSourceByName($dataSourceName) {
        $dataSourcesSubModels = $this->getDataSources();
        $dataSourceDirectory = $dataSourcesSubModels[$dataSourceName];
        return Configuration::factoryFromFileLocation($dataSourceDirectory, $dataSourceName);
    }

    private function getDataSources() {
        $ds = DIRECTORY_SEPARATOR;
        $gerDataSources = $this->getGerDataSources($ds);
    	$moduleDataSources = $this->getModuleDataSources($ds);
    	return array_merge($gerDataSources, $moduleDataSources);
    }

    private function getGerDataSources($ds) {
    	$dataSources = file_get_contents(__DIR__.$ds.'..'.$ds.'..'.$ds.'..'.$ds.'..'.$ds.'modules'.$ds.'acl'.$ds.'backend'.$ds.'config'.$ds.'dataSourcesMapping.json');
        $dataSources = str_replace('../../teknisa', '../modules/teknisa', $dataSources);
        return json_decode($dataSources, true);
    }

    private function getModuleDataSources($ds) {
    	$dataSources = file_get_contents(__DIR__.$ds.'..'.$ds.'..'.$ds.'..'.$ds.'config'.$ds.'dataSourcesMapping.json');
        return json_decode($dataSources, true);
    }
    
    /*public function getDataSourceByName($dataSourceName) {
        $ds = DIRECTORY_SEPARATOR;
        $file = file_get_contents(__DIR__.$ds.'..'.$ds.'..'.$ds.'..'.$ds.'config'.$ds.'dataSourcesMapping.json');
        $dataSourcesSubModels = json_decode($file, true);
        $dataSourceDirectory = $dataSourcesSubModels[$dataSourceName];
        return Configuration::factoryFromFileLocation($dataSourceDirectory, $dataSourceName);
    }*/

}