<?php

namespace Teknisa\CRM\Factory;

use Doctrine\ORM\EntityManager;

class EvolucaoFactory {

    protected $connection;

    public function __construct(EntityManager $entityManager) {
        
        $this->connection = $entityManager->getConnection();
        
    }
    
    public function requestForGetNrDiasLanceEvol($paramsSelectNrDiasLanceEvol){
        $querySelectNrDiasLanceEvol = "SELECT NRDIASLANCEVOL
                                        FROM CRM_PARAMETRIZACAO
                                        WHERE NRORG = :NRORG";   
                         
        try
        {
            $std = $this->connection->prepare($querySelectNrDiasLanceEvol);
            $std->execute($paramsSelectNrDiasLanceEvol);
            $nrDiasLanceEvol = $std->fetchAll();
            
        }catch (\Exception $e)
        {
            throw $e;
        }
        
        return $nrDiasLanceEvol;
    }
    
    /**
     * Retorna os anexos da evolução passada como parâmetro
     * 
     * @param {integer} nrorg Organização
     *        {integer} nrseqevolcont Evolução
     *        {integer} numberOfFiles Quantidade de anexos
     * 
    */
    public function getLastAttachments($nrorg, $nrseqevolcont, $numberOfFiles){
        $querySelectLastAttach = "SELECT DSCAMINHO, NMARQUIVO, DSTIPO
                                        FROM CRM_ANEXOCONTATO
                                        WHERE NRORG = $nrorg 
                                            AND NRORIGEM = $nrseqevolcont
                                            AND ROWNUM <= $numberOfFiles
                                        ORDER BY NRANEXOCONTATO";   
                         
        try
        {
            $std = $this->connection->prepare($querySelectLastAttach);
            $std->execute();
            $attach = $std->fetchAll();
            
        }catch (\Exception $e)
        {
            throw $e;
        }
        
        return $attach;
    }
    
    
}