<?php

namespace Teknisa\CRM\Factory;

use Doctrine\ORM\EntityManager;

class crm30000000CompromissoFactory {

    protected $connection;

    public function __construct(EntityManager $entityManager) {
        
        $this->connection = $entityManager->getConnection();
    }
    
    public function queryInsertCommitmentPart($paramsQuery){
        $insert = "INSERT INTO  PARTPLANOCUPA(CDOPERADOR, NRSEQPLANOCUPA, NRORG, CDINTEPLANOCUPA, DTINCLUSAO, NRORGINCLUSAO, 
                    CDOPERINCLUSAO)
         VALUES (:CDOPERADOR,
                 :NRSEQPLANOCUPA,
                 :NRORG,
                 :CDINTEPLANOCUPA,
                  SYSDATE,
                 :NRORGINCLUSAO,
                 :CDOPERINCLUSAO)";
        try
        {  
            $std = $this->connection->prepare($insert);
            $std->execute($paramsQuery);
        }
        catch(\Exception $e)
        {
            $e->getMessage();
        };
        
    }
    
    public function queryGetNrseqplanocupa($paramsQuery){
        $select = "SELECT NRSEQPLANOCUPA
                FROM PLANOCUPACAO
                WHERE TO_CHAR(DTINIPLANOCUPA, 'DD/MM/YYYY HH24:MI') = :DTINIPLANOCUPA";
        try
        {
            $std = $this->connection->prepare($select);
            $std->execute($paramsQuery);
            $retornoNrseqplanocupa = $std->fetchAll();
        }
        catch(\Exception $e)
        {
            $e->getMessage();
        };
        return $retornoNrseqplanocupa;
    }
    
    public function queryGetCommitmentParts($paramsQuery){
        try {
            $select = "SELECT DECODE(INITCAP(OPER.NMOPERADOR), NULL, INITCAP(PN.NMPRINCIPALPARC), INITCAP(OPER.NMOPERADOR)) NMOPERADOR, 
                            CASE
                              WHEN PART.CDOPERADOR IS NULL
                                THEN TO_CHAR(PART.NRPARCNEGOCIO)
                              WHEN PART.CDOPERADOR IS NOT NULL
                                THEN PART.CDOPERADOR
                              END AS CDOPERADOR, 
                            PN.CDTIPOPARCPRINCIPAL TIPO
                        FROM PARTPLANOCUPA PART 
                         LEFT JOIN OPERADOR OPER
                          ON PART.CDOPERADOR = OPER.CDOPERADOR
                           AND OPER.NRORG = PART.NRORG
                        LEFT JOIN PARCNEGOCIO PN 
                         ON (PN.NRPARCNEGOCIO = PART.NRPARCNEGOCIO  OR PN.NRPARCNEGOCIO = OPER.NRPARCNEGOCIO)
                          AND PN.NRORG = PART.NRORG
                        WHERE PART.NRSEQPLANOCUPA = :NRSEQPLANOCUPA";
            
            $std = $this->connection->prepare($select);
            $std->execute($paramsQuery);
            $retornoCommitmentParts = $std->fetchAll();
            
        }
        catch(\Exception $e) {
            $e->getMessage();
        };
        return $retornoCommitmentParts;
    }
    
    public function queryGetCommitmentInterlocs($nrorg, $nrparcnegocio){
        try {
            $select = "SELECT
                         NMINTERLOCUTOR AS NMOPERADOR,
                         NRSEQINTERLOCUTOR
                       FROM
                         CRM_INTERLOCUTOR INTER
                         JOIN PARCNEGOCIO PARC ON PARC.NRPARCNEGOCIO = INTER.NRPARCNEGOCIO
                                                AND PARC.NRORG = INTER.NRORG
                       WHERE
                         INTER.NRPARCNEGOCIO = '$nrparcnegocio'
                         AND INTER.NRORG = '$nrorg'";
            
            $std = $this->connection->prepare($select);
            $std->execute();
            $retornoCommitmentParts = $std->fetchAll();
            
            return $retornoCommitmentParts;
        }
        catch(\Exception $e) {
            $e->getMessage();
        };
    }
    
    public function getInterlocs($nrorg, $nrSeqInterlocs){
        try {
            $select = "SELECT
                         NMINTERLOCUTOR,
                         NRSEQINTERLOCUTOR,
                         EMAILINTERLOC
                       FROM
                         CRM_INTERLOCUTOR INTER
                       WHERE
                         INTER.NRSEQINTERLOCUTOR IN (:P_NRSEQINTERLOCS)
                         AND INTER.NRORG = :P_NRORG";
                         
            $params = array(
                "P_NRORG" => $nrorg,
                "P_NRSEQINTERLOCS" => $nrSeqInterlocs
            );
            
            $std = $this->connection->prepare($select);
            $std->execute($params);
            $interlocs = $std->fetchAll();
            
            return $interlocs;
        }
        catch(\Exception $e) {
            $e->getMessage();
        };
    }
    
    public function queryUpdateStatusPlanocupa($paramsQuery){
        $select = "UPDATE PLANOCUPACAO SET IDSTATPLANOCUPA = :IDSTATPLANOCUPA WHERE NRSEQPLANOCUPA = :NRSEQPLANOCUPA AND NRORG = :NRORG";
        try
        {
            $std = $this->connection->prepare($select);
            $std->execute($paramsQuery);
        }
        catch(\Exception $e)
        {
            $e->getMessage();
        };
    }
    
    public function queryDeleteCommitmentParts($paramsQuery){
        $delete = "DELETE FROM PARTPLANOCUPA
                    WHERE NRSEQPLANOCUPA = :NRSEQPLANOCUPA
                      AND NRORG = :NRORG";
        try
        {
            $std = $this->connection->prepare($delete);
            $std->execute($paramsQuery);
        }
        catch(\Exception $e)
        {
            $e->getMessage();
        };
    }
    
    public function queryDeleteCommitment($paramsQuery){
        $delete = "DELETE FROM PLANOCUPACAO
                    WHERE NRSEQPLANOCUPA = :NRSEQPLANOCUPA
                    AND NRORG = :NRORG";
        try
        {
            $std = $this->connection->prepare($delete);
            $std->execute($paramsQuery);
            
        }
        catch(\Exception $e)
        {
            $e->getMessage();
        };
    }
    
    public function getOperadores($paramsQuery){
        try {
            $query = "SELECT * FROM OPERADOR WHERE CDOPERADOR = :CDOPERADOR AND NRORG = :NRORG";
            $std = $this->connection->prepare($query);
            $std->execute($paramsQuery);
            $oper = $std->fetchAll();
            
            return $oper;
        }
        catch(\Exception $e) {
            $e->getMessage();
        };
    }
}